C++ Reimplementation of Fast Downward's Grounder
======

This is a reimplementation of Fast Downward's Datalog grounder (Helmert AIJ
2009) using C++. To run the baseline algorithm, you can run:

```
$ ./ground.py -i INSTANCE [--remove-action-predicates]
```

where `INSTANCE` is a PDDL task. The domain file can also be passed with `-d`
but it can also be inferred automatically (in most cases) assuming that instance
and file domains are in the same folder.

If you want to use "simplified program" for grounding (i.e., without action
predicates), simply add the flag `--remove-action-predicates`. See Correa et al
(ICAPS 2023) for more details.

(There are further options and parameteres in the codebase. These were added for
testing and for some experiments. We do not recommend their usage as that they
are not fully tested.)

*Note*: this version does not output the model because this generates too much
I/O overhead in larger instances. If you want to output the model, just
uncomment the `print_atom` lines on `src/grounder/main.cc`.

Instalation
--

We recommend setting up a Python virtual environment to execute the driver
script `ground.py`. After setting up the virtual environment, you can execute

```
$ pip install -r requirements.txt
```

to install all necessary Python packages.

To build the grounder, simply execute

```
$ ./build.py
```

Then, follow the usage described above.

Requirements
--
- Boost
- CMake 3.10 or higher
- Python 3.6+
